/* Copyright (C) Seth A. Robinson, 2003. 
 * All rights reserved worldwide.
 *
 * This software is provided "as is" without express or implied
 * warranties. You may freely copy and compile this source into
 * applications you distribute provided that the copyright text
 * below is included in the resulting source code, for example:
 * "Portions Copyright (C) Seth A. Robinson, 2003"
 */


#include "all.h"
#include "cassert"
#include <direct.h>


//should template this.  
bool number_is_close(int i_orig, int i_target, int i_range)
{
    if (i_orig > i_target)
    {
        if (i_orig <= i_target + i_range)
        {
            //close
            return true;
        }
        return false;
    } else
    {
        //less
        if (i_orig >= i_target - i_range)
        {
            return true;
        }
        return false;
    }
    
}

int random( long i_max)
{
    return (rand()%i_max);
}

//get next line from a stream (opened with above)

bool get_line_from_file(FILE * fp, char * dest)
{
    if( fgets( dest, 255, fp ) == NULL) return(false); else
        return(true); 
}


void getdir(char final[])
{
    //converted to non CString version that spits back path + filename separately.
    //Using	GetModuleFileName instead of ParamStr, works with Win2000/nt.
    char dir[MAX_PATH];
    char path[MAX_PATH];
    GetModuleFileNameA(NULL, path, MAX_PATH);
    char c_cur = 0;
    
    for (int k=strlen(path);path[k] != '\\'; k--)
    {
        c_cur = k;
    }
    strcpy(dir, "");
    //copy file name
    strncat((char*)&dir, &path[c_cur], strlen(path)-c_cur);
    path[c_cur] = 0; //truncate
    strcpy(final, path);
}	

 
void switch_to_current_dir()
{
    char dir_temp[MAX_PATH];
    getdir(dir_temp);
    //switch to dir run.exe is in
    chdir(dir_temp);
}

//replace all instances of szSearch with szReplace in the string

char *replace(char *szSearch, char *szReplace, char *szBuffer)
{
    int iSearchLen;
    char *p;
    char *p1;
    char *szDup;
    
    /* Start searching from the start */
    p1=szBuffer;
    iSearchLen=strlen(szSearch);
    
    /* Loop whilst search string is found in buffer */
    while((p=strstr(p1,szSearch))!=NULL)
    {
        szDup=strdup(szBuffer);
        
        /* Set found position to null */
        *p=0;
        
        /* Append replacement onto buffer */
        strcat(szBuffer,szReplace);
        
        /* Determine end of current replacement for next search */
        p1=szBuffer+strlen(szBuffer);
        
        /* Copy the rest of remaining string back on the end */
        strcat(szBuffer,(p-szBuffer)+iSearchLen+szDup);
        
        free(szDup);
    }
    
    return szBuffer;
}






